﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CodeWalker.GameFiles
{


    //shader parameter names used in drawables.
    //these were all extracted from MetaNames enum because their casing did not match the actual hash!
    //these should probably really only be used for display purposes.

    public enum ShaderParamNames : uint
    {
        _dimensionLOD2 = 2213330743,
        _fakedGrassNormal = 3847734030,
        _vecCollParams = 1235110448,
        _vecVehColl0B = 3443329873,
        _vecVehColl0M = 2054776271,
        _vecVehColl0R = 3676612388,
        _vecVehColl1B = 3338172776,
        _vecVehColl1M = 3731892311,
        _vecVehColl1R = 1839679119,
        _vecVehColl2B = 1542889970,
        _vecVehColl2M = 298913216,
        _vecVehColl2R = 3503557575,
        _vecVehColl3B = 2492173731,
        _vecVehColl3M = 2003587933,
        _vecVehColl3R = 3129694622,
        _vecVehCollB = 4034110113,
        _vecVehCollM = 4084115603,
        _vecVehCollR = 2902956998,
        Acceleration_Delta = 4042077187,
        accumulationBufferSampler0 = 8230410,
        accumulationBufferSampler1 = 272905623,
        activeShadowCascades = 2747556057,
        adapDOFProj = 711499858,
        AdapLumSampler = 2600073949,
        AdaptedLumMax = 735476279,
        AdaptedLumMin = 120989687,
        AdaptionParams = 994945211,
        AdaptiveDofDepthDownSampleParams = 530741887,
        adaptiveDOFExposureSampler = 2063861440,
        AdaptiveDofFocusDistanceDampingParams1 = 4192702981,
        AdaptiveDofFocusDistanceDampingParams2 = 3918393682,
        AdaptiveDOFOutputBuffer = 2655767810,
        AdaptiveDofParams0 = 1088399132,
        AdaptiveDofParams1 = 806028659,
        AdaptiveDofParams2 = 1767143429,
        AdaptiveDofParams3 = 2870836122,
        AdaptiveDOFParamsBuffer = 209455569,
        adaptiveDOFSampler = 2098736783,
        adaptiveDOFSamplerDepth = 718794333,
        AdaptTime = 1514540018,
        AirResist = 1208302886,
        alphaAdjust = 1287606900,
        AlphaMaskMapSampler = 1705051233,
        AlphaRange = 1331056747,
        AlphaScale = 931055822,
        AlphaTest = 950204405,
        alphaTestValue = 3310830370,
        altRemap = 285573515,
        AmbientDecalMask = 3686186843,
        AmbientLightingParams = 1614910597,
        ambientOcclusionContrast = 633061550,
        AmbientOccSampler = 1212577329,
        AnimatedNormalMapMask0Sampler = 2630205212,
        AnimatedNormalMapMask1Sampler = 1838164585,
        AnimatedNormalMapMask2Sampler = 2257753125,
        animatedNormalMapMod1 = 96407192,
        animatedNormalMapMod2 = 326478341,
        AnisoNoiseSpecSampler = 2134197289,
        AnisotropicAlphaBias = 363074471,
        anisotropicSpecularColour = 1673722929,
        anisotropicSpecularExponent = 499953092,
        anisotropicSpecularIntensity = 401654871,
        APlaneSampler = 1600333029,
        ApplyDamageSampler = 1117905904,
        approxTangent = 3606611481,
        ArmourStrength = 3061795481,
        AttenuationSampler = 483360323,
        AverageLuminanceOut = 1654447808,
        AvgLuminanceTexture = 1087818619,
        AzimuthColor = 360934156,
        AzimuthColorEast = 1882877478,
        azimuthEastColor = 1044876032,
        AzimuthHeight = 2649852765,
        AzimuthStrength = 2824307566,
        azimuthTransitionColor = 2670115477,
        azimuthTransitionPosition = 2764855899,
        azimuthWestColor = 1874413695,
        BackBufferSampler = 3700325701,
        BackBufferTexture = 3200056981,
        BaseSampler = 2669264211,
        baseTextureSampler = 1399472831,
        bDebugDisplayDamageMap = 727005071,
        bDebugDisplayDamageScale = 1720897181,
        Billboard = 552363713,
        blitSampler = 4098753311,
        BloodSampler = 1970149772,
        BloodSamplerVS = 3796090472,
        BloodZoneAdjust = 1011740581,
        bloomLum = 1959356754,
        BloomParams = 1213613006,
        BloomSampler = 1613750243,
        BloomSamplerG = 2187220839,
        BloomTexelSize = 3590118590,
        BlueOff = 1614062594,
        blurIntensity = 804387779,
        BlurSampler = 822703767,
        BlurVignettingParams = 871768731,
        BokehAlphaCutoff = 1703140281,
        BokehBrightnessParams = 1737665654,
        BokehEnableVar = 643379889,
        BokehGlobalAlpha = 1022881476,
        BokehNumAddedToBuckets = 2514924683,
        BokehParams1 = 3945388007,
        BokehParams2 = 4184896628,
        BokehPointBuffer = 2084769495,
        BokehSortedIndexBuffer = 1533187666,
        BokehSortedListBuffer = 201662228,
        BokehSortLevel = 2314931517,
        BokehSortLevelMask = 1605336858,
        BokehSortTransposeMatHeight = 3470273647,
        BokehSortTransposeMatWidth = 821002802,
        BokehSpritePointBuffer = 170997925,
        bottomSkyColour = 161676916,
        BoundRadius = 2230834649,
        branchBendPivot = 892666959,
        branchBendStiffnessAdjust = 3894262326,
        Brightness = 26603225,
        BrightnessSetting = 303513935,
        BrightTonemapParams0 = 118691255,
        BrightTonemapParams1 = 1904208559,
        BrokenBumpSampler = 2033191777,
        BrokenColor = 2817208061,
        BrokenDiffuseColor = 878330249,
        BrokenDiffuseSampler = 3349868497,
        BrokenGlassTileScale = 1356197901,
        BrokenSpecularColor = 1359397883,
        BrokenSpecularSampler = 3872409448,
        bumpiness = 4134611841,
        BumpSampler = 1186448975,
        BumpSampler_layer0 = 1073714531,
        BumpSampler_layer1 = 1422769919,
        BumpSampler_layer2 = 2745359528,
        BumpSampler_layer3 = 2975430677,
        BumpSampler_layer4 = 2417505683,
        BumpSampler_layer5 = 3720106230,
        BumpSampler_layer6 = 4091379000,
        BumpSampler2 = 1893875305,
        BumpSamplerFur = 2030333799,
        bumpSelfShadowAmount = 2907460320,
        BurnoutLimit = 2048742054,
        cBPlaneSampler = 1648690748,
        ChromAbParam = 2243268978,
        clippingPlane = 1632555383,
        ClipPlanes = 4225498643,
        ClothDarken = 4285790447,
        ClothDarkenColor = 2192646550,
        clothParentMatrix = 2335024113,
        ClothSweatMapSampler = 1059055951,
        ClothSweatSpec = 2469844039,
        cloudBaseColour = 2670795993,
        cloudBaseMinusMidColour = 207551193,
        CloudBias = 1077109597,
        cloudBillboardParams = 1372983410,
        CloudColor = 3245908258,
        cloudConstants1 = 1542931277,
        cloudConstants2 = 1848698816,
        cloudConstants3 = 3972097247,
        cloudDetailConstants = 2178269534,
        CloudFadeOut = 1796923256,
        CloudInscatteringRange = 1590938598,
        cloudLayerAnimScale1 = 2699058131,
        cloudLayerAnimScale2 = 2904978527,
        cloudLayerAnimScale3 = 1697604722,
        cloudMidColour = 3120184161,
        cloudShadowColour = 2429466598,
        cloudShadowMinusBaseColourTimesShadowStrength = 3681751999,
        CloudShadowOffset = 1192276656,
        CloudShadowStrength = 3469302040,
        CloudThicknessEdgeSmoothDetailScaleStrength = 2448643918,
        CloudThreshold = 2011404587,
        ClumpBump = 620873514,
        COCOutputTexture = 561614071,
        ColorCorrect = 1418724964,
        ColorCorrectHighLum = 1002641818,
        ColorFringeParams1 = 1315010326,
        ColorFringeParams2 = 94922157,
        colorHighLum = 3178323397,
        colorLowLum = 4274011020,
        colorLum = 819694290,
        ColorSampler = 3918882525,
        colorScaler = 2433112487,
        ColorShift = 3269836664,
        ColorShiftLowLum = 2775271800,
        ColorShiftScalar = 2106064165,
        ColorTexture = 934209648,
        ComboHeightSamplerFur = 455740840,
        ComboHeightSamplerFur01 = 1709265783,
        ComboHeightSamplerFur2 = 374924583,
        ComboHeightSamplerFur23 = 2930074258,
        ComboHeightSamplerFur3 = 2760212866,
        ComboHeightSamplerFur4 = 4056161278,
        ComboHeightSamplerFur45 = 2509158229,
        ComboHeightSamplerFur67 = 1396547512,
        ComboHeightTexMask = 285679314,
        Contrast = 699508084,
        ConvertSampler = 4959160,
        CoronasDepthMapSampler = 3603235271,
        CrackDecalBumpAlphaThreshold = 3343925161,
        CrackDecalBumpAmount = 2155296103,
        CrackDecalBumpTileScale = 730767419,
        CrackEdgeBumpAmount = 3420190257,
        CrackEdgeBumpTileScale = 492538267,
        crackleIntensity = 1771354266,
        CrackleSampler = 1774790613,
        CrackMatrix = 2644409350,
        CrackOffset = 2214698276,
        CrackSampler = 3328498618,
        cRPlaneSampler = 3915834095,
        cubeFace = 2567801214,
        CurLumSampler = 3431586341,
        currentDOFTechnique = 3543504858,
        currentLum = 968818364,
        currentResolution = 4182813263,
        curveCoeffs = 2763646717,
        DamagedWheelOffsets = 1348413520,
        DamageMultiplier = 378227101,
        DamageSampler = 3579349756,
        damageSpecTextureSampler = 3820652825,
        DamageTextureOffset = 4318529,
        damageTextureSampler = 4132715990,
        DamageVertBuffer = 2811144871,
        DarkTonemapParams0 = 1554855265,
        DarkTonemapParams1 = 780523795,
        deathIntensity = 2219791851,
        DeathSampler = 4146990968,
        debugCloudsParams = 580885775,
        debugLightColour = 227690714,
        DecalSampler = 2811948736,
        DecalTint = 3092072610,
        DecorationFrameInfo = 3729783099,
        DecorationTattooAdjust = 1578586549,
        DecorationTintPaletteSel = 2448945809,
        DecorationTintPaletteTexSampler = 4286164294,
        deferredLightDownsampleDepthSampler = 110250107,
        deferredLightParams = 1690620309,
        deferredLightScreenSize = 3811483225,
        deferredLightVolumeParams = 2130744975,
        deferredPerspectiveShearParams0 = 3433855881,
        deferredPerspectiveShearParams1 = 61303170,
        deferredPerspectiveShearParams2 = 4125937165,
        deferredProjectionParams = 424764587,
        deferredVolumeColour = 2115695095,
        deferredVolumeDepthBufferSamp = 3381865158,
        deferredVolumeDirection = 3203966112,
        deferredVolumePosition = 1009422528,
        deferredVolumeShaftCompositeMtx = 3101393666,
        deferredVolumeShaftGradient = 404580226,
        deferredVolumeShaftGradientColourInv = 1067440921,
        deferredVolumeShaftPlanes = 3122758957,
        deferredVolumeTangentXAndShaftRadius = 1118228408,
        deferredVolumeTangentYAndShaftLength = 4283942594,
        DensitySampler = 3828368598,
        DepthBlurHalfResSampler = 2333753907,
        DepthBlurHalfResTexture = 2638246296,
        DepthBlurSampler = 979379647,
        DepthBlurTexture = 4038110621,
        depthBuffer = 3447665758,
        depthBuffer2 = 1908423578,
        depthBuffer2_Sampler = 720934291,
        DepthBufferSamp = 2492728818,
        DepthBufferSampler = 3497598060,
        DepthMapPointSampler = 4215380418,
        DepthMapSampler = 847477652,
        DepthMapTexSampler = 2784473838,
        DepthSampler = 383876435,
        depthSourceSampler = 2578937463,
        depthTexture = 4088842947,
        DepthTextureMS = 4134029566,
        deSatContrastGamma = 1070958827,
        Desaturate = 2639337807,
        desaturateTint = 2511699259,
        detailBumpiness = 1675037470,
        DetailBumpSampler = 143227613,
        DetailDensity2Sampler = 2587222892,
        DetailDensitySampler = 2270155403,
        detailMapOffset = 3032413960,
        DetailMapSampler = 1041827691,
        detailMapUScale = 489333004,
        detailMapVScale = 2830921123,
        DetailNormal2Sampler = 2004179855,
        DetailNormalSampler = 2903840997,
        DetailOffset = 2002782257,
        DetailSampler = 3393362404,
        detailSettings = 3038654095,
        detailUVScale = 3418497265,
        diffuse2SpecMod = 1788442252,
        diffuseCol = 1517692383,
        DiffuseExtraSampler = 58635929,
        DiffuseHfSampler = 2946270081,
        diffuseMod = 1685953011,
        DiffuseNoBorderTexSampler = 1732587965,
        DiffuseSampler = 4059966321,
        DiffuseSampler2 = 181641832,
        DiffuseSampler3 = 1429813046, //thanks CP
        DiffuseSamplerFur = 1282320680,
        DiffuseSamplerPhase2 = 3227619449,
        DiffuseSamplerPoint = 4015001285,
        DiffuseSplatterTexSampler = 1412546033,
        DiffuseTexSampler = 3004704155,
        DiffuseTexSampler01 = 255045494,
        DiffuseTexSampler02 = 2707084226,
        DiffuseTexSampler03 = 2981196911,
        DiffuseTexSampler04 = 3291650421,
        DiffuseTexTileUV = 2816002123,
        DiffuseWoundTexSampler = 3758481220,
        DiffusionRadius = 4024070401,
        dimmerSet = 1523312743,
        dimmerSetPacked = 4182305072,
        DirectionalMotionBlurIterParams = 2777949533,
        DirectionalMotionBlurLength = 544111294,
        DirectionalMotionBlurParams = 3408424243,
        dirtColor = 1146381126,
        DirtDecalMask = 1050016400,
        dirtLevel = 47191856,
        dirtLevelMod = 3961814809,
        DirtSampler = 2124031998,
        DirtBumpSampler = 3157820509,//thanks CP
        DiskBrakeGlow = 1035405954,
        displParams = 1163050293,
        distanceMapSampler = 1616890976,
        DistEpsilonScaleMin = 1163639717,
        DistMapCenterVal = 1612602645,
        distortionParams = 2957679312,
        DistortionSampler = 342449994,
        ditherSampler = 612917610,
        dofBlur = 731686132,
        DofBlurWeight = 706444485,
        dofDist = 3329041621,
        dofInten = 3552457075,
        dofNoBlurBlendRingSize = 413916545,
        dofNoBlurRadius = 108398598,
        DOFOutputTexture = 3487236658,
        dofProj = 2305108861,
        dofProjCompute = 2729164810,
        dofRenderTargetSize = 3995371223,
        DOFSampler = 2614429576,
        dofShear = 1387749709,
        dofSkyWeightModifier = 1603770318,
        DOFTargetSize = 3565962906,
        downsampledDepthSampler = 2057740952,
        DownsampleDepthSampler = 498175796,
        dpMapFarClip = 3395601267,
        dpMapNearClip = 479573217,
        drawBucket = 514782960,
        dReflectionParams = 153627866,
        droopParams = 2926981594,
        DruggedEffectColorShift = 4028255612,
        DruggedEffectParams = 858398664,
        dShadowMatrix = 3423656318,
        dShadowOffsetScale = 930807775,
        dShadowParam0123 = 3916656767,
        dShadowParam4567 = 584100066,
        dShadowParam891113 = 1698928349,
        DstTextureSize = 45365902,
        eaaParams2 = 1422359808,
        earlyOut = 3422479905,
        earlyOut_Sampler = 2971523439,
        earlyOutParams = 141437565,
        EastColor = 1417575779,
        EdgeMarkParams = 717226593,
        EdgeThreshold = 2670218238,
        EdgeThresholdMin = 316543927,
        effectsConstants = 1179101422,
        ElapsedTime = 4152310215,
        emissiveMultiplier = 1592520008,
        emissiveReflectMultiplier = 1347035993,
        EmitterParamLifeAndSpeed = 1295421465,
        EmitterParamPos = 2286595424,
        EmitterParamPosRange = 3505097448,
        EmitterParamProbablityPhase2 = 1652433309,
        EmitterTransform = 2216438402,
        EmitterVelocityBoxPos = 1027158774,
        EmitterVelocityBoxRange = 3202652030,
        EnvBloodBinormal = 304838968,
        EnvBloodData = 2241230170,
        EnvBloodPos = 3704052925,
        EnvBloodSampler = 3616483953,
        EnvBloodTangent = 1134317228,
        envEffFatThickness = 436649803,
        envEffScale = 2431974683,
        envEffTexTileUV = 3670603239,
        envEffThickness = 2702504809,
        EnvironmentSampler = 3317411368,
        Exposure = 2538078618,
        ExposureClampAndHistory = 2911392042,
        ExposureCurve = 1836476954,
        ExposureParams0 = 2329380491,
        ExposureParams1 = 1031924697,
        ExposureParams2 = 1253836365,
        ExposureParams3 = 301405380,
        Exposures = 2947662557,
        ExposureSwitches = 1784826898,
        faceTextureSampler = 624309278,
        facetMask = 4034105764,
        Fade_Thickness = 205855514,
        fadeAlphaDist = 4164097433,
        fadeAlphaDistUmTimer = 3637887135,
        fadeAlphaLOD1Dist = 3563207876,
        fadeAlphaLOD2Dist = 1294165969,
        fadeAlphaLOD2DistFar0 = 4248689351,
        fAge = 2063122051,
        FallOffAndKernelParam = 1703468999,
        fillColor = 3014106266,
        Filmic0 = 2611530409,
        fIntensity = 847954571,
        FlowSampler = 1214194352,
        FoamSampler = 3266349336,
        FogColor = 3922291195,
        FogParams = 1243028310,
        FogRayTexSampler = 1487203018,
        FogSampler = 2568933054,
        fogVolumeColor = 2907231751,
        fogVolumeDepthSampler = 1087981784,
        fogVolumeInvTransform = 786602411,
        fogVolumeParams = 10424280,
        fogVolumePosition = 2937842810,
        fogVolumeTransform = 1406518664,
        foliageBranchBendPivot = 353881103,
        foliageBranchBendStiffnessAdjust = 3429332683,
        FontNormalSampler = 3140496408,
        FontNormalScale = 91417371,
        FontSampler = 2048139100,
        FontTexture = 3394800319,
        fourPlaneDof = 2764191939,
        fpvMotionBlurSize = 1677050762,
        fpvMotionBlurVelocity = 4116905408,
        fpvMotionBlurWeights = 4038439571,
        FrameMap = 1835157646,
        FrameMapTexSampler = 507369750,
        Frequency1 = 2441536523,
        Frequency2 = 2219624855,
        fresnelRolloff = 3796399242,
        FullSampler = 3157511856,
        furAlphaClip03 = 290288684,
        furAlphaClip47 = 4280570754,
        furAlphaDistance = 4141869331,
        furAOBlend = 4026629301,
        furAttenCoef = 2491165204,
        furBendParams = 3489000159,
        furDitherAlphaFadeParams = 3407922321,
        furGlobalParams = 443249107,
        furLayerParams = 1122745807,
        furLayerParams2 = 3825466177,
        furLayerParams3 = 1668577832,
        furLayerStep = 1208356461,
        furLength = 1430134069,
        FurMaskSampler = 3794875320,
        furMaxLayers = 253873259,
        furMinLayers = 3007864804,
        furNoiseUVScale = 1008743034,
        furNumLayers = 110936794,
        furSelfShadowMin = 3093266608,
        furShadow03 = 1104745269,
        furShadow47 = 711397225,
        furStiffness = 2137279259,
        furUvScales = 897751165,
        g_AlphaFade = 1960511459,
        g_BloodColor = 985986992,
        g_BloodSplatParams = 1621619881,
        g_CPQSMix_QSFadeIn = 2799702011,
        g_CurrentValue = 1312005277,
        g_EdgeHighlightColour = 1596321467,
        g_f4RTSize = 4169783008,
        g_fBilateralCoefficient = 2015612345,
        g_fBilateralEdgeThreshold = 2771898508,
        g_fCollisionSqScale = 731874660,
        g_fEnableSpringForces = 2189248122,
        g_fGrassSpringRigidity = 3152689414,
        g_fGrassSpringScale = 2339438728,
        g_fRippleRainStrength = 2044767128,
        g_fSSAOBilateralCoef = 145680953,
        g_fSSAOKernelScale = 3370811738,
        g_fVolumetricLightRayIntensityMult = 3709677333,
        g_GBufferTexture3Param = 3145202593,
        g_GhostLevel = 1563742563,
        g_HDAO_Params1 = 1535730194,
        g_HDAO_Params2 = 3676889419,
        g_HDAOApplyParams = 2705555169,
        g_HDAOComputeParams = 2528000437,
        g_HDAOExtraParams = 3628503020,
        g_HDAOValleyParams = 1466262319,
        g_HighlightScale = 1705698884,
        g_ImposterSize = 786569893,
        g_LightningStrikeNoiseParams = 390679343,
        g_LightningStrikeParams = 3780586083,
        g_LinearClampSampler = 2261256735,
        g_MSAAPointTexture1_Dim = 3319333866,
        g_MSAAPointTexture2_Dim = 3715862146,
        g_OcclusionTextureParams = 4007914843,
        g_PointSampler = 3230386348,
        g_projParams = 360593454,
        g_projShear = 1833194361,
        g_Puddle_ScaleXY_Range = 529156535,
        g_PuddleParams = 3536830402,
        g_ResultTexture = 3349637075,
        g_SSAOStrength = 1519496158,
        g_targetSize = 1149055682,
        g_TextColour = 3414941892,
        g_TextShadowColour = 3326514923,
        g_TextShadowScale = 828975922,
        g_vCollisionParams = 390873962,
        g_vCollisionSpheres = 2187899533,
        g_vPlayerPosition = 148353768,
        g_vRelativeLuminanceThresholdParams = 1353171807,
        g_vRippleAttributes = 1686992389,
        g_vRippleTexelSize = 2041279531,
        g_vTexelSize = 1568580394,
        g_WaveXOffset = 2340128792,
        g_WaveXZoom = 1940934038,
        g_WaveYZoom = 936340354,
        g_WidthScalar = 1482315230,
        gActiveUnit = 247068080,
        GalaxyOffset = 2261454336,
        GalaxySampler = 304699295,
        gAlphaCutoffMinMax = 3012586280,
        gAlphaTest = 2215224122,
        gAlphaToCoverageScale = 955152299,
        gAmbientAmount = 862548646,
        gAmbientColor = 2502793579,
        gAmbientMult = 2621865253,
        gAmbientShadow = 1730637860,
        Gamma = 1617619096,
        GammaCorrection = 2923835982,
        gAnimatedNormalMapParams = 1356180523,
        gAnimBlendWeights = 3438696362,
        gAnimCombine = 4162938569,
        gAnimSculpt = 732819097,
        GaussianWeights = 3546535582,
        gBackgroundDistortionAlphaBooster = 1266153517,
        gBackgroundDistortionAmount = 2358946644,
        gBackgroundDistortionVisibilityPercentage = 1950755416,
        gBiasToCamera = 969255365,
        gBlitMatrix = 1903406607,
        gBloodData = 2470245206,
        gBloodUVBoundsPage = 318462180,
        gBlurAmount = 2372939986,
        gBoneDamage0 = 493675041,
        gBoneDamageEnabled = 3445557846,
        gBounceColor = 3285219193,
        gBoxCentrePos = 1213320064,
        gBoxForward = 2141719324,
        gBoxRight = 3950477470,
        gBoxSize = 4157270760,
        GBufferStencilTextureSampler = 34323572,
        gbufferTexture0 = 1370576551,
        gbufferTexture2 = 989669695,
        gbufferTextureDepth = 3214151316,
        GBufferTextureSampler0 = 3101514270,
        GBufferTextureSampler1 = 1931628197,
        GBufferTextureSampler2 = 1601349446,
        GBufferTextureSampler3 = 394499945,
        GBufferTextureSamplerDepth = 3001958741,
        GBufferTextureSamplerSSAODepth = 566345585,
        gCableParams = 3557855020,
        gCamAngleLimits = 1391293880,
        gCameraBias = 481136556,
        gCameraDistanceAtMaxDisplacement = 894396470,
        gCameraPos = 130109679,
        gCameraPosition = 3861036523,
        gCameraShrink = 196757553,
        gClipPlanes = 993087185,
        gCloudColor = 3349623462,
        gCloudViewProj = 1388118204,
        gCollisionLifeModifier = 28882798,
        gCollisionPositionModifier = 1413333801,
        gCollisionVelocityModifier = 2917041400,
        gColorTint = 1945696018,
        gColorTintPhase2 = 3971978241,
        gColour = 819380429,
        gColourSplash = 2769897443,
        gControlLight = 1458962865,
        gCrossFadeDistance = 2123742775,
        gCSMParticleShadowSamp = 18467538,
        gCSMParticleShadowTexture = 1879733647,
        gCSMShaderVars_deferred = 4041368736,
        gDayNightScale = 2033466401,
        gDecalChannelSelection = 129604674,
        gDecalNormalSampler = 353477773,
        gDecalSampler = 2317915042,
        gDeferredInverseViewProjMatrix = 3129339935,
        gDeferredLightColourAndIntensity = 3618208763,
        gDeferredLightConeAngle = 1457978794,
        gDeferredLightConeAngleI = 3706722404,
        gDeferredLightConeOffset = 2681954581,
        gDeferredLightConeScale = 3587849890,
        gDeferredLightDirection = 3096160936,
        gDeferredLightInvSqrRadius = 1076369960,
        gDeferredLightPosition = 3515628483,
        gDeferredLightRadius = 771816156,
        gDeferredLightRadiusProjShearParams = 507484242,
        gDeferredLightSampler = 1527752693,
        gDeferredLightSampler0P = 3029377315,
        gDeferredLightSampler1 = 575604989,
        gDeferredLightSampler2 = 1424289320,
        gDeferredLightShadowMap0 = 2826529087,
        gDeferredLightShadowMap1 = 2589969676,
        gDeferredLightShadowMap2 = 2224923016,
        gDeferredLightShadowMap3 = 1962213943,
        gDeferredLightShaftParams = 2784101259,
        gDeferredLightTangent = 3997363695,
        gDeferredLightType = 874695930,
        gDeferredLightVolumeParams = 371509596,
        gDeferredProjParams = 1174638206,
        gDeferredVolumeRadiusScale = 3037897088,
        gDensityShiftScale = 3043875162,
        gDepthViewProjMtx = 512139429,
        gDiffuse = 1220611861,
        gDirectional = 2203405262,
        gDirectionalLightShadowAmount = 3920559848,
        gDirectionalMotionBlurLength = 2219759593,
        gDirectionalMult = 4000928118,
        gDirectionalVelocityAdd = 1608450430,
        gDirectionalZOffsetMinRange = 955747368,
        gDirNormalBias = 1480114695,
        gDispersalSettings = 570820137,
        gDistanceScale = 3645463202,
        gEastMinusWestColor = 2332609458,
        gEdgeSoftness = 867642987,
        GeneralParams0 = 3458676571,
        GeneralParams1 = 3166540936,
        gExtraLightMult = 3645170126,
        gExtraLights = 2849007823,
        gExtraParams0 = 1363351178,
        gExtraParams1 = 3423931440,
        gExtraParams2 = 4223069043,
        gExtraParams3 = 3907306959,
        gExtraParams4 = 2518327352,
        gFadeInOut = 1682568218,
        gFadeNearFar = 1244256289,
        gFadeZBaseLoHi = 542136670,
        gFirstTimeUpdate = 92947686,
        gFogCompositeAmbientColor = 2918893733,
        gFogCompositeDirectionalColor = 646659969,
        gFogCompositeParams = 3080532465,
        gFogCompositeTexOffset = 1705135815,
        gFrustumParameters = 1069442784,
        gGrassSkipInstance = 3294601711,
        gGravityWindTimeStepCut = 2189578124,
        gGustAmplifier = 1813609204,
        gGustSpacing = 2572448010,
        gHDRExposure = 1986583430,
        gHeatHaze = 1822868744,
        gHeatHazeRippleLength = 1850681702,
        gHeatHazeRippleRate = 3558453078,
        gHeatHazeScale = 3312170287,
        gHeatHazeSize = 1319873596,
        gHeatHazeWidth = 3133152963,
        gHeatPhase = 2721110750,
        gHitPlane = 3729639013,
        ghorizScale = 2467525454,
        gHybridAddRatio = 3504408232,
        gInstanceVars = 3432648184,
        gInstCullParams = 3871720938,
        gIntensity = 3311833552,
        gInterpolationFactor = 1392131636,
        gIsShadowPass = 1999109769,
        gLifeFade = 1079477869,
        gLifeMinMaxClampToGround = 3942952480,
        gLifeTimeScale = 3294686231,
        gLightIntensityClamp = 4186188647,
        gLightIntensityMult = 1884220195,
        gLightSettings = 1029904424,
        globalAnimUV0 = 3617324062,
        globalAnimUV1 = 3126116752,
        globalFogRayFadeParam = 1248095708,
        globalFogRayParam = 1620085657,
        globalFreeAimDir = 3943027507,
        gLocalLightsMultiplier = 4293612306,
        gLodFadeControlRange = 4185950307,
        gLodFadePower = 2662986932,
        gLodFadeRange = 3264171975,
        gLodFadeStartDist = 1949054155,
        gLodFadeTileScale = 1082098581,
        gLodInstantTransition = 596864795,
        gLodThresholds = 979130770,
        gLowResDepthSampler = 2824212180,
        gLowResDepthTexture = 3015483598,
        gMaxDisplacement = 1164495840,
        gMaxLife = 3970444018,
        gMirrorBounds = 1887204037,
        gMirrorCrackAmount = 1562064116,
        gMirrorCrackSampler = 2984091644,
        gMirrorDebugParams = 496893366,
        gMirrorDistortionAmount = 987148199,
        gMotionBlur = 294407736,
        gNearFarQMult = 2513511302,
        gNormalArc = 808788377,
        gNormalHeight = 3146080364,
        gNormalMapMult = 3282331164,
        gNormalOffset = 2355039984,
        gNormalScale = 2365712398,
        gNumClipPlanes = 828848872,
        gOffsetParticlePos = 842278893,
        gOffsetScale0 = 70492586,
        gOffsetScale1 = 428526680,
        goldFactor = 358396505,
        goldFresnelRolloff = 295546023,
        goldReflectColorBase = 2396384524,
        goldReflectColorOverlay = 2603016628,
        goldReflectivePower = 2990597200,
        goldSpecMapIntMask = 1333698176,
        goldSpecularFactor = 435211370,
        GolfTrailTextureSamp = 241657115,
        gooDeferredLightScreenSize = 3073062802,
        gOrientToTerrain = 3165461554,
        gParticleColorPercentage = 1853363478,
        gParticleTextureSize = 2550169896,
        gPerspectiveShearParams0 = 2149148446,
        gPerspectiveShearParams1 = 509977564,
        gPerspectiveShearParams2 = 263128687,
        gPiercingLightPower_Strength_NormalStrength_Thickness = 2302032860,
        gPositionOffset = 2734209203,
        gPositionScale = 4212665338,
        gPower = 1384422613,
        gPrevViewProj = 1120562824,
        gProjParams = 2311871851,
        GradientFilterColBottom = 3762433606,
        GradientFilterColMiddle = 1794637696,
        GradientFilterColTop = 4015194706,
        gRadius = 526220184,
        gRainDebug = 1247076385,
        gravityDroop = 3181978688,
        GreenOff = 3283681954,
        gReflScales = 1520419346,
        gRefParticlePos = 2705128804,
        gRefraction = 2643069888,
        gRescaleUV1 = 724216589,
        gRescaleUV2 = 2046871736,
        gRescaleUV3 = 2259804698,
        gResetParticles = 2831259018,
        gRG_BlendEndDistance = 3347456804,
        gRG_BlendStartDistance = 4179423620,
        gRotationCenter = 2718167535,
        gRotSpeedMinRange = 3733294048,
        groundColor = 3169191053,
        gScaleDiffuseFillAmbient = 397913198,
        gScaleFade = 3144708943,
        gScaleRange = 4248652172,
        gScatterG_GSquared_PhaseMult_Scale = 987241318,
        gShadowAmount = 3297538021,
        gSizeMinMax = 1571728947,
        gSizeMinRange = 3419056622,
        gSkyColor = 3328933361,
        gSoftness = 2874180382,
        gSoftnessCurve = 2667435005,
        gSoftnessShadowMult = 2718764463,
        gSoftnessShadowOffset = 2710273761,
        gSoftParticleRange = 3901093204,
        gSpecularExponent = 3204977572,
        gSpecularIntensity = 247886295,
        gSplashFrames = 944333453,
        gSplashSizeMinMax = 4062424283,
        gSunColor = 3007207522,
        gSunDirection = 2009439163,
        gSuperAlpha = 1225534059,
        gSurfaceSettings = 3834090438,
        gtaSkyDomeClip = 964033580,
        gtaSkyDomeFade = 826009472,
        gtaWaterColor = 4280744704,
        gTexCoordScaleOffset0 = 3099617970,
        gTexCoordScaleOffset1 = 2745647232,
        gTexCoordScaleOffset2 = 2499388197,
        gTexCoordScaleOffset3 = 2456002041,
        gTextureAngleRads = 241993590,
        gTextureAnimation = 20918084,
        gTextureAnimRateScaleOverLifeStart2End2 = 3412279679,
        gTextureRowsCols = 1276450911,
        gTextureRowsColsStartEnd = 1241308942,
        gTotalLifeTimeScale = 2824822244,
        gUseComputeShaderOutputBuffer = 1009029736,
        gUseDirectional = 1281964389,
        gUseShadows = 345674786,
        gUVOffset = 3300015766,
        gUVOffset1 = 2565276602,
        gUVOffset2 = 2325899053,
        gUVOffset3 = 3510465638,
        gVelocityMax = 3037552071,
        gVelocityMin = 507774218,
        gvertScale = 1074904593,
        gViewProj = 4124209033,
        gVolumeLightsSampler = 1687175937,
        gVolumeLightsTexture = 2884407863,
        gWaterHeight = 446050918,
        gWestColor = 3223173913,
        gWindBaseVel = 3813992546,
        gWindBendingGlobals = 709598663,
        gWindBendScaleVar = 2552738797,
        gWindGustVel = 2099280216,
        gWindMultParams = 982613925,
        gWindParams = 3536772057,
        gWindVarianceVel = 2216170969,
        gWorldBinormal = 2267341197,
        gWorldInstanceInverseTranspose = 1914807,
        gWorldInstanceMatrix = 981286173,
        gWorldTangent = 1317093162,
        gWrapBias = 1858190163,
        gWrapLighting = 75905342,
        gWrapLighting_MSAARef = 833328952,
        gWrapScale = 3087563039,
        gZdampen = 2165766204,
        HardAlphaBlend = 3913511942,
        HDRColorTexture = 2362960420,
        HDRExposure = 3039323892,
        HDRExposureClamp = 1487577326,
        hdrIntensity = 4136287658,
        HDRIntensityMultiplier = 1498595219,
        HDRPointSampler = 3702694755,
        HDRSampler = 1709735268,
        HDRSunExposure = 81989056,
        HDRTextureAA = 2769796592,
        HeatHazeOffsetParams = 234272229,
        HeatHazeParams = 3041693270,
        HeatHazeSampler = 2900829390,
        HeatHazeTex1Params = 157461750,
        HeatHazeTex2Params = 3686416465,
        heightBias = 330974467,
        heightBias0 = 537974167,
        heightBias1 = 820082484,
        heightBias2 = 3378489398,
        heightBias3 = 3161525849,
        HeightFogParams = 4202365273,
        HeightMapSampler = 1008099585,
        heightMapSamplerLayer0 = 781078585,
        heightMapSamplerLayer1 = 2570495372,
        heightMapSamplerLayer2 = 2346748640,
        heightMapSamplerLayer3 = 2242969217,
        HeightMapTransformMtx = 1556799447,
        HeightOpacity = 2935469584,
        heightSampler = 4049987115,
        heightScale = 947222050,
        heightScale0 = 2807156689,
        heightScale1 = 1898472319,
        heightScale2 = 2178811114,
        heightScale3 = 1536800866,
        heightTexture = 4152773162,
        HemiCubeSampler = 145567721,
        hiDofMiscParams = 851407070,
        hiDofParams = 3302089350,
        HighDetailNoiseBumpSampler = 1044331566,
        HighDetailNoiseSampler = 3822359214,
        highDetailSampler = 860147427,
        highLum = 737146002,
        HmdWarpParam = 4161661017,
        horizonLevel = 403229780,
        HybridAdd = 4234023609,
        HybridAddRatio = 1902453223,
        ImageFXParams = 3775812724,
        importanceBufferSampler = 1983941369,
        imposterDir = 15105794,
        imposterSampler = 4013138833,
        imposterWorldX = 3187870439,
        imposterWorldY = 3495145352,
        imposterWorldZ = 4037865530,
        InitPositionTexSampler = 867916958,
        InitVelocityTexSampler = 3796043845,
        InputTex = 2352384719,
        InstanceBuffer = 571392628,
        InterlaceIndex = 92545662,
        InterlaceMapSampler = 4281682490,
        InterlaceTotalNum = 1200425084,
        intermediateTarget = 2216618306,
        intermediateTarget_Sampler = 1179275796,
        intermediateTargetAA = 2580729000,
        JitterSampler = 887426944,
        kernelParam = 348424870,
        kernelRadius = 1819724113,
        KillFlashCol = 1705946031,
        KillFlashUVOff = 1449898229,
        LaserSampler = 3973852449,
        LaserVisibilityMinMax = 2050561467,
        LastBufferSize = 878694393,
        LensArtefactsParams0 = 1487316152,
        LensArtefactsParams1 = 870406958,
        LensArtefactsParams2 = 1165295189,
        LensArtefactsParams3 = 263361233,
        LensArtefactsParams4 = 2409501354,
        LensArtefactsParams5 = 1794558296,
        LensCenter = 163655085,
        LensDistortionParams = 705844615,
        LetterIndex1 = 1794007338,
        LetterIndex2 = 865825409,
        LetterSize = 1497980819,
        LicensePlateFontExtents = 3015810411,
        LicensePlateFontTint = 1846736030,
        LightColor = 1945364554,
        LightDir = 1608210580,
        LightOcclusionSampler = 3039301469,
        lightrayParams = 912013868,
        lightrayParams2 = 3575716412,
        LightStreaksBlurDir = 2085391682,
        LightStreaksColorShift0 = 4082051348,
        LinearSampler = 2135833848,
        LinearSampler1 = 4052371224,
        LinearSampler2 = 2627575128,
        LinearWrapSampler = 681732347,
        LinearWrapSampler2 = 1379901712,
        LinearWrapTexture3 = 4011882001,
        lookupSampler = 2295086480,
        lowLum = 2175272747,
        LowResDepthMapPointSampler = 1894550764,
        LowResDepthPointMap = 4131434726,
        LumFilterParams = 2120745528,
        LuminanceConstants = 2215984599,
        LuminanceDownsampleOOSrcDstSize = 1869154352,
        lunarCycle = 3166975708,
        manualDepthTest = 2024632841,
        MaskAlphaReverse = 3046988116,
        maskTextureSampler = 2110569141,
        matDiffuseColor = 408880252,
        matDiffuseColor2 = 1577977996,
        matDiffuseColorTint = 99676333,
        materialDiffuse = 424198508,
        materialIdSampler = 892830080,
        materialWetnessMultiplier = 3170143313,
        matGrassTransform = 72771513,
        matMaterialColorScale = 2492093682,
        matWheelTransform = 2829072482,
        matWheelWorld = 3178367768,
        matWheelWorldViewProj = 2078334811,
        MBPerspectiveShearParams0 = 1033188477,
        MBPerspectiveShearParams1 = 2555242989,
        MBPerspectiveShearParams2 = 2292140688,
        MBPrevViewProjMatrixW = 556540040,
        MBPrevViewProjMatrixX = 2198692937,
        MBPrevViewProjMatrixY = 2433876050,
        MipMapLod = 482766300,
        mirrorIntensity = 2215660639,
        mirrorNormalIntensity = 1531688027,
        mirrorParams = 2538518895,
        mirrorReflectionSkyIntensity = 3525553109,
        mirrorSpecMaskIntensity = 2901241109,
        MLAAAreaLUTSampler = 2609019681,
        MLAALinearSampler = 655764451,
        MLAAPointSampler = 1645524956,
        moonColor = 2213576281,
        MoonColorConstant = 2616626323,
        moonDirection = 3484629706,
        MoonGlow = 2037987613,
        MoonGlowSampler = 2151873246,
        moonIntensity = 2342189917,
        MoonLight = 2593156215,
        moonPosition = 124803246,
        moonSampler = 1534106922,
        moonTexConvert = 1796762296,
        MoonTexPosition = 1128557715,
        MoonVisiblity = 3257982346,
        MoonXVector = 1764174018,
        MoonYVector = 3157759019,
        motionBlurMatrix = 2950235179,
        MotionBlurSampler = 3974544708,
        MP_BulletTimeParams = 51894946,
        MSAAPointSampler1 = 3816347419,
        MSAAPointTexture1 = 750933622,
        MSAAPointTexture2 = 989590249,
        nearFarClip = 1899734512,
        Noise1Sampler = 3941892287,
        Noise2Sampler = 215717268,
        noiseDensityOffset = 3780934309,
        NoiseFilterArea = 1418684055,
        noiseFrequency = 1364176943,
        noiseHighLum = 3113827561,
        noiseLowLum = 3302331435,
        noiseLum = 1493025892,
        NoiseMapSampler = 2678081716,
        NoiseParams = 2296796634,
        noisePhase = 1916643725,
        NoiseSampler = 2461808165,
        noiseScale = 4186750186,
        noiseSoftness = 984327287,
        NoiseTexSampler = 651303591,
        noiseTexture = 1661149109,
        NoiseTextureSampler = 4127640691,
        noiseThreshold = 188180875,
        NoiseWarp = 1708817206,
        normalBuffer = 3727614344,
        normalBufferSamp = 3334794412,
        normalMapBlendRatio = 432051653,
        normalMapMod = 1363116819,
        NormalMapSampler = 860923645,
        NormalMapSampler1 = 225912280,
        NormalMapSampler2 = 4224746123,
        NormalMapTexSampler = 2007347265,
        normalSampler = 2327911600,
        NormalSpecMapTexSampler = 2275171214,
        normalTexture = 3453458978,
        NormalTextureSampler = 53266845,
        NormBufferSampler = 2450983583,
        normFresnelRolloff = 469438475,
        normReflectivePower = 99909810,
        normSpecMapIntMask = 4286481776,
        normSpecularFactor = 106090312,
        normTable = 478874367,
        numActiveShadowCascades = 2608506194,
        NumLetters = 1303240218,
        occlusionSampler = 50748941,
        occlusionTexture = 2967810622,
        OceanLocalParams0 = 2333080707,
        offsetHighLum = 3768233024,
        offsetLowLum = 1745892694,
        offsetLum = 3139368420,
        orderNumber = 1617153586,
        paletteColor0 = 2390234167,
        paletteColor1 = 345546874,
        paletteColor2 = 650331343,
        paletteColor3 = 1102019239,
        paletteIndex = 2499973182,
        PaletteSampler = 2950395616,
        paletteSelector = 2636279676,
        paletteSelector2 = 588791948,
        ParabSampler = 2604688681,
        parallaxScaleBias = 2178632789,
        parallaxSelfShadowAmount = 242286661,
        params_ = 890816472,
        ParticleCollisionSampler = 3713958763,
        ParticlePosTexSampler = 2603657112,
        ParticlePosXYTexSampler = 2279694207,
        ParticlePosZWTexSampler = 1408622679,
        particleShadowsParams = 2589755661,
        ParticleVelTexSampler = 1792971393,
        ParticleVelXYTexSampler = 3377719961,
        ParticleVelZWTexSampler = 572101329,
        PedBrightness = 2965570322,
        PerlinNoiseSampler = 2192344499,
        perlinSampler = 3428612092,
        Persistance = 319450804,
        perspectiveShearParam = 686675449,
        Phase = 2726250539,
        plantColor = 1360494706,
        PlateBgBumpSampler = 1709116366,
        PlateBgSampler = 1342317448,
        PLAYER_MASK = 2584097651,
        PlayerBrightness = 1987993393,
        playerLFootPos = 1466936,
        playerRFootPos = 982297002,
        PointSampler = 1728781698,
        PointSampler1 = 857651826,
        PointSampler2 = 2186729701,
        PointTexture1 = 3319640342,
        PointTexture2 = 463756450,
        PointTexture3 = 715389601,
        PointTexture4 = 4030629335,
        PointTexture5 = 4280230808,
        polyRejectThreshold = 3669125377,
        PositionTexSampler = 124136329,
        PostFXAdaptiveDofCustomPlanesParams = 2921923875,
        PostFXAdaptiveDofEnvBlurParams = 383528417,
        PostFxSampler2 = 3640527007,
        PostFxSampler3 = 1268084184,
        postProcess_FlipDepth_NearPlaneFade_Params = 1212194473,
        projectionParams = 4041985547,
        PRTOccSampler = 3756087939,
        PtfxAlphaMapSampler = 2528190781,
        PtfxDepthMapSampler = 3549846349,
        PuddleBumpSampler = 644999851,
        PuddleMaskSampler = 1899494261,
        PuddlePlayerBumpSampler = 375060758,
        QuadAlpha = 319478650,
        QuadPosition = 4152407657,
        QuadScale = 876246817,
        QuadTexCoords = 2382487901,
        QualitySubpix = 1192820550,
        radialBlurCenter = 265875256,
        RadialBlurSampler = 6871558,
        radialBlurSampleScale = 1978511676,
        radialBlurScale = 847338530,
        radialBlurTextureStep = 3637740945,
        RadialFadeArea = 3417034203,
        RadialFadeTime = 820208297,
        RadialWaveParam = 4020440334,
        RainNormalControls = 2413728713,
        RainNormalSampler = 205121072,
        RawInstanceBuffer = 2533822745,
        rcpFrame = 3616804746,
        RedOff = 550595403,
        reductionDepthTexture = 156102219,
        ReductionOutputTexture = 3090928251,
        RefBlurMapSampler = 553137719,
        ReflectanceSampler = 2024624668,
        reflectivePower = 1002989215,
        reflectivePowerED = 680514554,
        ReflectTextureSampler = 2975449189,
        refMipBlurParams = 309170118,
        RefMipBlurSampler = 3559513422,
        RefractionMapTexSampler = 3189040505,
        RefractSampler = 2398824821,
        RenderCubeMapSampler = 3123859691,
        RenderMapPointSampler = 1552806584,
        RenderMapPointSamplerMSAA = 840576025,
        RenderPointMapINT = 3218359854,
        RenderPointMapINTParam = 945456412,
        RenderTargetSize = 2592035668,
        RenderTexArray = 183558417,
        RenderTexArraySampler = 1776075411,
        RenderTexFmask = 334637039,
        RenderTexMSAA = 2388364099,
        RenderTexMSAAINT = 1120019968,
        RenderTexMSAAParam = 445950974,
        RESERVE_VS_CONST_c253 = 888979958,
        RESERVE_VS_CONST_c254 = 572824646,
        RESERVE_VS_CONST_c255 = 3578071436,
        ResolvedDepthSampler = 870591330,
        ResolvedDepthTexture = 1168394501,
        Result = 1204638111,
        rimAmount = 3950947166,
        rimPower = 1017175370,
        RippleBumpiness = 3108440880,
        RippleData = 1154845288,
        RippleScale = 3553443429,
        RippleScaleOffset = 1931187426,
        RippleSpeed = 1172914979,
        ropeColor = 3402942199,
        sampFiltered = 200703167,
        sampleAngle = 1030071922,
        sampleScale = 65527032,
        ScaleIn = 1489667163,
        scalerLum = 1241172112,
        ScanlineFilterParams = 3994711222,
        ScreenBlurFade = 337464727,
        ScreenCenter = 2855930302,
        screenRes = 2982944708,
        ScreenRez = 1216400687,
        ScreenSizeHalfScale = 3116016449,
        SeamTextureSampler = 1888072213,
        seeThroughColorFar = 3831201608,
        seeThroughColorNear = 3012901639,
        seeThroughColorVisibleBase = 2159046948,
        seeThroughColorVisibleWarm = 3370209405,
        seeThroughParams = 4084639067,
        SegmentSize = 2511004421,
        SelfShadowing = 1840833647,
        SfxWindSampler3D = 2060224441,
        shader_cableAmbient = 2538368771,
        shader_cableDiffuse = 1793087594,
        shader_cableDiffuse2 = 115414613,
        shader_cableEmissive = 132015748,
        shader_fadeExponent = 2415019593,
        shader_radiusScale = 2225356731,
        shader_windAmount = 33262047,
        shaderVariables = 2308502112,
        ShadowFacingOffset = 2069856698,
        ShadowFalloff = 1293272419,
        shadowMapSamp = 4212336983,
        shadowParams2 = 2293499745,
        skinColourTweak = 2856526403,
        SkinParams = 441924618,
        SkyColor = 1706854363,
        SkyMapSampler = 2000097477,
        skyPlaneColor = 3575965978,
        skyPlaneParams = 2005428036,
        smallCloudColorHdr = 1741381730,
        smallCloudColorXHdrIntensity = 2180964324,
        smallCloudConstants = 376734756,
        SmartBlitCubeMapSampler = 4204135808,
        SmartBlitCubeMapTexture = 712004116,
        SmartBlitSampler = 909202272,
        SmartBlitTexture = 4234899854,
        SmokeParams = 2945162076,
        SmokeSampler = 2479196183,
        SnowSampler = 3153629680,
        SnowSampler0 = 43291740,
        SnowSampler1 = 296170113,
        SoakFrameInfo = 2322806119,
        SpecDesaturateExponent = 3019471088,
        SpecDesaturateIntensity = 716647240,
        SpecExp = 191070201,
        specFalloffAdjust = 227128491,
        specFresnelExp = 1058370591,
        specFresnelMax = 4192555480,
        specFresnelMin = 1243102889,
        SpecIntensity = 3710484485,
        specIntensityAdjust = 4171608282,
        specMapExpMask = 1709596004,
        specMapIntMask = 4279333149,
        specMapReflectMask = 3348420270,
        SpecSampler = 1619499462,
        SpecSampler_layer01 = 2048257998,
        SpecSampler_layer23 = 3596135066,
        specTexTileUV = 1430901041,
        specular2Color = 685871723,
        specular2Color_DirLerp = 2732605880,
        specular2ColorIntensity = 3929351910,
        specular2ColorIntensityED = 1998056897,
        specular2ColorIntensityRE = 4172410899,
        specular2Factor = 629012244,
        specular2FactorED = 3425067163,
        specularColorFactor = 1212833469,
        specularColorFactor1 = 475502710,
        specularColorFactor2 = 1361248780,
        specularColorFactor3 = 1060953664,
        specularColorFactorED = 1250428158,
        specularFactor = 376311761,
        specularFactor1 = 1627805193,
        specularFactor2 = 2405249722,
        specularFactor3 = 3075146389,
        specularFactorED = 2497120655,
        SpecularFalloff = 3957040118,
        specularFalloffMult = 2272544384,
        specularFalloffMultSpecMap = 2748867194,
        specularFresnel = 666481402,
        SpecularIntensity = 2841625909,
        specularIntensityMult = 4095226703,
        specularIntensityMultSpecMap = 1058366663,
        specularNoiseMapUVScaleFactor = 3472765508,
        SpecularPower = 2313518026,
        speedConstants = 4031543803,
        sphereReflectionSkyIntensity = 798112437,
        SplatterFrameInfo = 1795230185,
        srcTextureSize = 2371438916,
        sslrCenter = 2233700119,
        sslrParams = 2393555267,
        SSLRSampler = 362115574,
        StarFieldBrightness = 257351982,
        starfieldIntensity = 1720801864,
        StarFieldSampler = 4148544921,
        StarFieldUVRepeat = 2211182669,
        StarThreshold = 2069166037,
        StencilCopy = 2849038798,
        StencilCopySampler = 2084502919,
        StencilCopyTexture = 526908546,
        StencilTech = 471113370,
        StippleSampler = 3178703610,
        StubbleControl = 3996109161,
        SubColor = 3318550136,
        SubScatWidth = 993622972,
        SubScatWrap = 511449331,
        SubsurfaceColor = 1759569064,
        SubsurfaceIntensity = 1096960668,
        SubsurfaceRollOff = 3870878664,
        SubViewportParams = 2820867500,
        SunAxias = 2561150543,
        SunCentre = 240054980,
        sunColor = 891485471,
        sunColorHdr = 1049428866,
        sunColour = 1204497173,
        sunConstants = 1546824331,
        sunDirection = 2607379178,
        sunDiscColor = 3557539369,
        sunDiscColorHdr = 1079908950,
        SunElevation = 569130658,
        sunHdrIntensity = 3152536124,
        sunPosition = 2950046911,
        SunRaysParams = 291571442,
        SunsetColor = 2702399089,
        SunSize = 1478210724,
        SurfaceTextureSampler = 3864743319,
        SweatMapSampler = 2330958813,
        switchOn = 3150944317,
        targetSize = 1880392259,
        targetSizeParam = 1053269285,
        TearGasParams = 1288904305,
        TerrainGridCentrePos = 3625956620,
        TerrainGridForward = 1519085164,
        TerrainGridHighHeightCol = 580500403,
        TerrainGridLowHeightCol = 2936084960,
        TerrainGridMidHeightCol = 2606299729,
        TerrainGridParams = 1298168495,
        TerrainGridParams2 = 3179684830,
        TerrainGridRight = 1294931141,
        tessellationMultiplier = 1934793340,
        TexelSize = 3160646551,
        Texm = 169731954,
        TextureClamp = 812052183,
        TextureGrassSampler = 4087226378,
        TextureNoWrapSampler = 2957556365,
        textureSamp = 485865047,
        TextureSampler = 726757629,
        TextureSampler_layer0 = 3576369631,
        TextureSampler_layer1 = 606121937,
        TextureSampler_layer2 = 831736502,
        TextureSampler_layer3 = 2025281789,
        TextureSampler_layer4 = 235963313,
        TextureSampler_layer5 = 1429049834,
        TextureSampler_layer6 = 1784855636,
        TextureSampler2 = 90460676,
        TextureSamplerDiffPal = 2878898974,
        TextureSize = 3986548189,
        TiledLightingSampler = 3579496475,
        TimeOfDay = 1778950238,
        TintBlendAmount = 481228442,
        tintBlendLayer0 = 549865893,
        tintBlendLayer1 = 3618355041,
        tintBlendLayer2 = 3305181708,
        tintBlendLayer3 = 4225662918,
        tintBumpiness = 3412667425,
        tintBumpSampler = 3461703736,
        TintIntensity = 3676759262,
        TintPaletteSampler = 4131954791,
        tintPaletteSelector = 4258764495,
        tintSampler = 1530343050,
        tonemapColorFilterParams0 = 324960120,
        tonemapColorFilterParams1 = 48979602,
        TonemapParams = 2402343587,
        TopCloudBiasDetailThresholdHeight = 2470194715,
        TopCloudColor = 2654156795,
        TopCloudDetail = 3891329052,
        TopCloudHeight = 1826174990,
        TopCloudLight = 1738437051,
        TopCloudThreshold = 1907493970,
        topLum = 2532426199,
        TotalElapsedTime = 3838297418,
        TrackAnimUV = 3759799674,
        TransColor = 2460231751,
        TransparentDstMapSampler = 2450925918,
        TransparentSrcMap = 2768420156,
        TransparentSrcMapSampler = 3675757750,
        TransPos = 3580147959,
        TransTex0 = 719147892,
        TransTex1 = 1023997899,
        TransTex2 = 88705101,
        treeLod2Normal = 1105633214,
        treeLod2Params = 1951298816,
        txABC_Texture = 737921561,
        txCOC_Texture = 849209715,
        txX_Texture = 2443058410,
        txYn_Texture = 314367857,
        tyreDeformParams = 1573146290,
        tyreDeformParams2 = 4085683888,
        tyreDeformSwitchOn = 1318515464,
        UIColor = 2438354415,
        UIColorXformOffset = 805638785,
        UIColorXformScale = 1696850869,
        UIPosMtx = 2371642382,
        UIPremultiplyAlpha = 653605664,
        UITex0Mtx = 1320157902,
        UITex1Mtx = 2219459259,
        UITexture0 = 3890278027,
        UITexture1 = 3587000932,
        umGlobalOverrideParams = 3341722211,
        umGlobalParams = 570415642,
        uMovementParams = 3156484982,
        umTriWave1Params = 1002429420,
        umTriWave2Params = 1181853954,
        umTriWave3Params = 2191838184,
        UnderLightStrength = 618284065,
        unsharpAmount = 982234565,
        UpdateOffset = 1690179723,
        UpdateParams0 = 1210532871,
        UpdateParams1 = 1947442147,
        useTessellation = 1176544093,
        UseTreeNormals = 3771895108,
        UVScalar = 2343745306,
        uvScales = 2395163223,
        vBoneVelocitiesX = 58804251,
        vBoneVelocitiesY = 2266287952,
        vCustomData = 2809044919,
        vecBatchAabbDelta = 2709975619,
        vecBatchAabbMin = 1568822605,
        vecCameraPos = 3890753729,
        vecPlayerPos = 2050268192,
        vehglassCrackTextureParams = 3043112491,
        vehglassCrackTextureSampler = 3541769459,
        VelocityBufferSampler = 415075366,
        VelocityMapSampler = 3944176109,
        VelocityTexSampler = 2305380067,
        vHairParams = 4131157628,
        viewProj = 1758764692,
        viewToWorldProjectionParam = 3809745575,
        VignettingColor = 587686680,
        VignettingParams = 2870132669,
        VisibleInstanceBuffer0 = 3815124047,
        VisibleInstanceBuffer1 = 774685147,
        VisibleInstanceBuffer2 = 443193943,
        VisibleInstanceBuffer3 = 2592414350,
        vNoiseParams = 1120961721,
        VolumeSampler = 789275230,
        vSkinSweat = 3181015961,
        vSweatParams = 3596190507,
        WaterBumpParams = 126236009,
        waterColor = 4201563883,
        WaterColorSampler = 1938107181,
        waterColour = 217812784,
        WaterFogFadeColor = 93338982,
        waterfogPtfxParams = 1185901400,
        WaterHeight = 276101176,
        waterIntensity = 3098236963,
        waterReflectionScale = 386931249,
        waterReflectionSkyIntensity = 4202734524,
        waterRenderSimParam = 3115418423,
        WaterRippleSampler = 3870579404,
        waterSimParam = 1441798312,
        waterSimParams1 = 764072840,
        waterSimParams2 = 2978995088,
        WaterSurfaceSampler = 4239336251,
        waterTexResValue = 1128648105,
        WaveMovement = 683816830,
        WaveOffset = 2296487471,
        WestColor = 2977103135,
        WetAnisotropicSpecular = 1297501138,
        WetAnisotropicSpecularColour = 4244410187,
        WetDarken = 3170546064,
        wetnessMultiplier = 853385205,
        WindGlobalParams = 208642390,
        WindStr = 3237952635,
        WoundFrameInfo = 2347313451,
        wrapAmount = 477869607,
        wrapLigthtingTerm = 850731621,
        WrinkleMaskSampler_0 = 2261465245,
        WrinkleMaskSampler_1 = 3567506505,
        WrinkleMaskSampler_2 = 2959477710,
        WrinkleMaskSampler_3 = 3181913682,
        WrinkleMaskSampler_4 = 199377605,
        WrinkleMaskSampler_5 = 498853496,
        wrinkleMaskStrengths0 = 3696993600,
        wrinkleMaskStrengths1 = 3993356436,
        wrinkleMaskStrengths2 = 9399719,
        wrinkleMaskStrengths3 = 1226342076,
        WrinkleSampler_A = 2285332697,
        WrinkleSampler_B = 163310560,
        YPlaneSampler = 2291309475,
        YUVtoRGB = 361269406,
        zenithColor = 1379881353,
        zenithConstants = 2801684,
        zenithTransitionColor = 3025743240,
        ZoomBlurMaskSize = 1914884772,
        ZoomFocusDistance = 2687037299,
        zShift = 2743864906,
        zShiftScale = 273550094,
    }



}
